"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function replaceImportPath(_a) {
    var t = _a.types;
    return {
        name: 'replace-import',
        visitor: {
            ImportDeclaration: function (path, _a) {
                var _b = _a.opts, opts = _b === void 0 ? {} : _b;
                if (Array.isArray(opts)) {
                    opts.forEach(function (opt) {
                        replaceImport(path, opt);
                    });
                }
                else {
                    replaceImport(path, opts);
                }
            },
            CallExpression: function (path, _a) {
                var _b = _a.opts, opts = _b === void 0 ? {} : _b;
                if (path.node.callee.name === 'require') {
                    var specifier_1 = path.node.arguments[0];
                    if (specifier_1 && specifier_1.type === 'StringLiteral') {
                        if (Array.isArray(opts)) {
                            opts.forEach(function (opt) {
                                replaceRequire(specifier_1, opt);
                            });
                        }
                        else {
                            replaceRequire(specifier_1, opts);
                        }
                    }
                }
            },
        },
    };
}
exports.default = replaceImportPath;
// for (const extension in extensions) {
//     const regExp = new RegExp(`${extension}$`)
//     if (regExp.test(specifier.value)) {
//         specifier.value = specifier.value.replace(regExp, extensions[extension])
//         break
//     }
// }
function replaceImport(path, opts) {
    var src = opts.src, dest = opts.dest;
    if (!src || !dest) {
        console.error('src & dest should be provided in babel-plugin-replace-import-path');
        return;
    }
    var node = path.node;
    if (!node || !src) {
        return;
    }
    if (typeof src === 'string') {
        if (node.source.value === src) {
            node.source.value = dest;
        }
    }
    else {
        // src is a regex
        node.source.value = node.source.value.replace(src, dest);
    }
}
function replaceRequire(specifier, opts) {
    var src = opts.src, dest = opts.dest;
    if (!specifier || !src) {
        return;
    }
    if (typeof src === 'string') {
        if (specifier.value === src) {
            specifier.value = dest;
        }
    }
    else {
        // src is a regex
        specifier.value = specifier.value.replace(src, dest);
    }
}
